/* 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   Copyright (c) Alexey Mahotkin <alexm@hsys.msk.ru> 2001

   Test-suite for Access Control Lists

*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "branch-acl.h"
#include "check_acl.h"

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_IO_H
#include <io.h>
#endif

int
main (void)
{
    int fd;

    check_nonexisting_file_acl("./test-acl");

    /* create that file */
    if ((fd = creat("./test-acl/foo", 0644)) == -1) {
	perror("check_acl");
	exit (1);
    }
    if (close(fd) == -1) {
	perror("check_acl");
	exit(1);
    }

    check_existing_file_acl("./test-acl");

    check_parsing_branch_permissions();

    check_on_branch_acl();

    check_default_dir_on_branch_acl();

    check_persistent_on_branch_acl("./test-acl");

    check_reading_acl_file();

    exit (0);
}
