
#include "user-acl.h"

#include <assert.h>
#include <stdlib.h>

int
main (void)
{
    char ann[] = "ann";

    USER_ACL *user_acl = NULL;
    USER_ACE *user_ace;

    /* no users in empty list */
    user_ace = get_user_ace (user_acl, "ann");
    assert(user_ace == NULL);

    /* set permissions for user */
    user_acl = set_user_ace (NULL, ann, 10);
    assert(user_acl != NULL);
    strcpy(ann, "xxx");

    /* check that they are the same as were set, even if the original
       username gets overwritten */
    user_ace = get_user_ace (user_acl, "ann");
    assert(user_ace != NULL);
    assert(user_ace->perm == 10);
    assert(user_ace->username != NULL);
    assert(strcmp(user_acl->username, "ann") == 0);

    /* check that no other user gets any permission */
    user_ace = get_user_ace (user_acl, "bob");
    assert(user_ace == NULL);

    /* set permissions for second user */
    user_acl = set_user_ace (user_acl, "bob", 20);

    /* check that they are the same as were set */
    user_ace = get_user_ace(user_acl, "bob");
    assert(user_acl != NULL);
    assert(user_ace->perm == 20);
    assert(user_ace->username != NULL);
    assert(strcmp(user_acl->username, "bob") == 0);

    /* check that permissions for first user are still accessible */
    user_ace = get_user_ace (user_acl, "ann");
    assert(user_ace != NULL);
    assert(user_ace->perm == 10);
    assert(user_ace->username != NULL);
    assert(strcmp(user_ace->username, "ann") == 0);

    /* reset permissions for first user */
    user_acl = set_user_ace (NULL, "ann", 25);
    assert(user_acl != NULL);

    /* check that they are the same as were set */
    user_ace = get_user_ace (user_acl, "ann");
    assert(user_ace != NULL);
    assert(user_ace->perm == 25);
    assert(user_ace->username != NULL);
    assert(strcmp(user_acl->username, "ann") == 0);

    exit(0);
}
