
#include "config.h"

#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "zlib-ncli-common.h"

#include "network-client.h"
#include "fd-client.h"
#include "zlib-client.h"

int
main (void)
{
    NCLI fdncli;
    NCLI zncli;

    fdncli = create_fd_client(0, 1, NULL, ncli_error);
    assert(fdncli != NULL);

    zncli = create_zlib_client(NULL, ncli_error);
    assert(zncli != NULL);
    put_ncli_on_top_of_another(&fdncli, zncli);

    assert(zncli->connect(zncli));

    while (!feof(stdin)) {
	char buf[BUFSIZ];

	int read = zncli->read(zncli, buf, BUFSIZ);
	if (read == -1) {
	    if (errno == EAGAIN)
		continue;
	    perror("zlib-ncli-reader");
	}
	if (read == 0)
	    break;
	assert(read > -1);

	fwrite(buf, 1, read, stdout);
    }

    exit(0);
}
