
#include "config.h"

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "zlib-ncli-common.h"

#include "network-client.h"
#include "fd-client.h"
#include "zlib-client.h"

int
main (void)
{
    NCLI fdncli;
    NCLI zncli;

    fdncli = create_fd_client(0, 1, NULL, ncli_error);
    assert(fdncli != NULL);

    zncli = create_zlib_client(NULL, ncli_error);
    assert(zncli != NULL);
    put_ncli_on_top_of_another(&fdncli, zncli);

    assert(zncli->connect(zncli));

    while (!feof(stdin)) {
	char buf[BUFSIZ];
	int read = fread(buf, 1, sizeof buf, stdin);
	assert(zncli->write(zncli, buf, read) == NCLI_SUCCESS);
    }

    exit(0);
}
